<?php
namespace Df\GoogleFont\Fonts;
use Df\GoogleFont\Font\Variant\Preview\Params;
class Fs extends \Df\Core\O {
	/**
	 * 2015-12-08
	 * @param string[] $relativeParts
	 * @return string
	 */
	function absolute(array $relativeParts) {
		return $this->baseAbsolute() . df_cc_path($relativeParts);
	}

	/**
	 * 2015-12-08
	 * @return string
	 */
	function nameColorsSizeMargin() {
		if (!isset($this->{__METHOD__})) {
			$this->{__METHOD__} = implode('_', [
				's' . df_pad0(2, $this->params()->fontSize())
				, 'f' . implode('-', $this->params()->fontColor())
				, 'b' . implode('-', $this->params()->bgColor())
				, 'm' . $this->params()->marginLeft()
			]);
		}
		return $this->{__METHOD__};
	}

	/**
	 * 2015-12-08
	 * @param string[] $params
	 * @return string
	 */
	function namePng(array $params) {return df_fs_name(implode('_', $params)) . '.png';}

	/**
	 * 2015-12-08
	 * @return string
	 */
	function nameResolution() {
		if (!isset($this->{__METHOD__})) {
			$this->{__METHOD__} = implode('x', [$this->params()->width(), $this->params()->height()]);
		}
		return $this->{__METHOD__};
	}

	/** @return string */
	private function baseAbsolute() {return df_media_path_absolute(self::baseRelative());}

	/** @return string */
	private function baseRelative() {return df_cc_path_t('df', 'api', 'google', 'fonts');}

	/** @return Params */
	private function params() {return Params::fromRequest();}
}